/*
 Copyright (c) 2000  
 International Computer Science Institute
 All rights reserved.

 This file may contain software code originally developed for the
 Sting project. The Sting software carries the following copyright:

 Copyright (c) 1998, 1999
 Stefan Savage and the University of Washington.
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 3. All advertising materials mentioning features or use of this software
    must display the following acknowledgment:
      This product includes software developed by ACIRI, the AT&T
      Center for Internet Research at ICSI (the International Computer
      Science Institute). This product may also include software developed
      by Stefan Savage at the University of Washington.  
 4. The names of ACIRI, ICSI, Stefan Savage and University of Washington
    may not be used to endorse or promote products derived from this software
    without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY ICSI AND CONTRIBUTORS ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED.  IN NO EVENT SHALL ICSI OR CONTRIBUTORS BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.
*/

#ifndef _TBIT
#define _TBIT

#define SEQ_LT(a,b) ((int)((a)-(b)) < 0)
#define SEQ_LEQ(a,b) ((int)((a)-(b)) <= 0)
#define SEQ_GT(a,b) ((int)((a)-(b)) > 0)
#define SEQ_GEQ(a,b) ((int)((a)-(b)) >= 0)

#define PLOTDIFF 0.00009 

#define DEFAULT_TARGETPORT  (80)
#define DEFAULT_FILENAME ""
#define DEFAULT_MSS 16 
#define DEFUALT_MAXWIN_PKTS 5
#define DEFAULT_RTT 0.1

#define RTT_TO_MULT 5
#define SYNTIMEOUT    (2.0)  
#define REXMITDELAY (2.0)
#define MAXSYNRETRANSMITS  (2)
#define MAXDATARETRANSMITS  (2)

/*
enum tbit_status {
 FAIL,                       
 SUCCESS,                    
 NO_TARGET_CANON_INFO,
 NO_LOCAL_HOSTNAME ,
 NO_SRC_CANON_INFO,
 NO_SESSION_ESTABLISH ,
 MSS_TOO_SMALL,
 BAD_ARGS,
 FIREWALL_ERR,
 ERR_SOCKET_OPEN,
 ERR_SOCKOPT,
 ERR_MEM_ALLOC,
 NO_CONNECTION,
 MSS_ERR,
 BUFFER_OVERFLOW,
 UNWANTED_PKT_DROP,
 EARLY_RST,
 UNEXPECTED_PKT,
 DIFF_FLOW,
 ERR_CHECKSUM,
 NOT_ENOUGH_PKTS,
 BAD_OPT_LEN,
 TOO_MANY_PKTS,
 NO_DATA_RCVD,
 NO_TRGET_SPECIFIED ,
 BAD_OPTIONS,
 TOO_MANY_TIMEOUTS,
 TOO_MANY_RXMTS,
 NO_SACK,
 ERR_IN_SB_CALC,
 TOO_MANY_HOLES,
 TOO_MANY_DROPS,
 LAST_TBIT_STATUS 
};
*/

#define  FAIL                         -1  
#define  SUCCESS                    0  
#define  NO_TARGET_CANON_INFO        1    
#define  NO_LOCAL_HOSTNAME           2  
#define  NO_SRC_CANON_INFO          3  
#define  NO_SESSION_ESTABLISH       4  
#define  MSS_TOO_SMALL               5  
#define  BAD_ARGS                   6  
#define  FIREWALL_ERR               7  
#define  ERR_SOCKET_OPEN             8
#define  ERR_SOCKOPT                 9
#define  ERR_MEM_ALLOC               10
#define  NO_CONNECTION               11  
#define  MSS_ERR                    12  
#define  BUFFER_OVERFLOW            13
#define  UNWANTED_PKT_DROP          14  
#define  EARLY_RST                   15  
#define  UNEXPECTED_PKT               16
#define  DIFF_FLOW                   17  
#define  ERR_CHECKSUM                 18
#define  NOT_ENOUGH_PKTS            19  
#define  BAD_OPT_LEN                20
#define  TOO_MANY_PKTS              21  
#define  NO_DATA_RCVD                22  
#define  NO_TRGET_SPECIFIED         23  
#define  BAD_OPTIONS                24  
#define  TOO_MANY_TIMEOUTS          25  
#define  TOO_MANY_RXMTS              26  
#define  NO_SACK                    27  
#define  ERR_IN_SB_CALC              28  
#define  TOO_MANY_HOLES              29  
#define  TOO_MANY_DROPS              30  
#define  UNWANTED_PKT_REORDER				 31

#endif
